## freeradius 3.2.7%2Bdfsg

=== raddb/certs/Makefile ===
######################################################################
#
#	Make file to be installed in /etc/raddb/certs to enable
#	the easy creation of certificates.
#
#	See the README file in this directory for more information.
#
#	$Id: 34948bd9248a6953de3696abcd2088a7a5cee014 $
#
######################################################################

DH_KEY_SIZE	= 2048
OPENSSL		= openssl
EXTERNAL_CA	= $(wildcard external_ca.*)

ifneq "$(EXTERNAL_CA)" ""
PARTIAL		= -partial_chain
endif

#
#  Set the passwords
#
include passwords.mk

######################################################################
#
#  Make the necessary files, but not client certificates.
#
######################################################################
.PHONY: all
all: index.txt serial ca server client

.PHONY: client
client: client.pem

.PHONY: ca
ca: ca.der ca.crl

.PHONY: server
server: server.pem server.vrfy

.PHONY: inner-server
inner-server: inner-server.pem inner-server.vrfy

.PHONY: verify
verify: server.vrfy client.vrfy

passwords.mk: server.cnf ca.cnf client.cnf inner-server.cnf
	@echo "PASSWORD_SERVER	= '$(shell grep output_password server.cnf | sed 's/.*=//;s/^ *//')'"		> $@
	@echo "PASSWORD_INNER	= '$(shell grep output_password inner-server.cnf | sed 's/.*=//;s/^ *//')'"	>> $@
	@echo "PASSWORD_CA	= '$(shell grep output_password ca.cnf | sed 's/.*=//;s/^ *//')'"		>> $@
	@echo "PASSWORD_CLIENT	= '$(shell grep output_password client.cnf | sed 's/.*=//;s/^ *//')'"		>> $@
	@echo "USER_NAME	= '$(shell grep emailAddress client.cnf | grep '@' | sed 's/.*=//;s/^ *//')'"	>> $@
	@echo "CA_DEFAULT_DAYS  = '$(shell grep default_days ca.cnf | sed 's/.*=//;s/^ *//')'"			>> $@

######################################################################
#
#  Diffie-Hellman parameters
#
######################################################################
dh:
	$(OPENSSL) dhparam -out dh -2 $(DH_KEY_SIZE)

######################################################################
#
#  Create a new self-signed CA certificate
#
######################################################################
ca.key ca.pem: ca.cnf
	@[ -f index.txt ] || $(MAKE) index.txt
	@[ -f serial ] || $(MAKE) serial
	$(OPENSSL) req -new -x509 -keyout ca.key -out ca.pem \
		-days $(CA_DEFAULT_DAYS) -config ./ca.cnf \
		-passin pass:$(PASSWORD_CA) -passout pass:$(PASSWORD_CA)
	chmod g+r ca.key

ca.der: ca.pem
	$(OPENSSL) x509 -inform PEM -outform DER -in ca.pem -out ca.der

ca.crl: ca.pem
	$(OPENSSL) ca -gencrl -keyfile ca.key -cert ca.pem -config ./ca.cnf -out ca-crl.pem -key $(PASSWORD_CA)
	$(OPENSSL) crl -in ca-crl.pem -outform der -out ca.crl
	rm ca-crl.pem

######################################################################
#
#  Create a new server certificate, signed by the above CA.
#
######################################################################
server.csr server.key: server.cnf
	$(OPENSSL) req -new  -out server.csr -keyout server.key -config ./server.cnf
	chmod g+r server.key

server.crt: ca.key ca.pem server.csr
	$(OPENSSL) ca -batch -keyfile ca.key -cert ca.pem -in server.csr  -key $(PASSWORD_CA) -out server.crt -extensions xpserver_ext -extfile xpextensions -config ./server.cnf

server.p12: server.crt
	$(OPENSSL) pkcs12 -export -in server.crt -inkey server.key -out server.p12  -passin pass:$(PASSWORD_SERVER) -passout pass:$(PASSWORD_SERVER)
	chmod g+r server.p12

server.pem: server.p12
	$(OPENSSL) pkcs12 -in server.p12 -out server.pem -passin pass:$(PASSWORD_SERVER) -passout pass:$(PASSWORD_SERVER)
	chmod g+r server.pem

.PHONY: server.vrfy
server.vrfy: ca.pem
	@$(OPENSSL) verify $(PARTIAL) -CAfile ca.pem server.pem

######################################################################
#
#  Create a new client certificate, signed by the the above server
#  certificate.
#
######################################################################
client.csr client.key: client.cnf
	$(OPENSSL) req -new  -out client.csr -keyout client.key -config ./client.cnf
	chmod g+r client.key

client.crt: ca.key ca.pem client.csr
	$(OPENSSL) ca -batch -keyfile ca.key -cert ca.pem -in client.csr  -key $(PASSWORD_CA) -out client.crt -extensions xpclient_ext -extfile xpextensions -config ./client.cnf

client.p12: client.crt
	$(OPENSSL) pkcs12 -export -in client.crt -inkey client.key -out client.p12  -passin pass:$(PASSWORD_CLIENT) -passout pass:$(PASSWORD_CLIENT)
	chmod g+r client.p12
	cp client.p12 $(USER_NAME).p12

client.pem: client.p12
	$(OPENSSL) pkcs12 -in client.p12 -out client.pem -passin pass:$(PASSWORD_CLIENT) -passout pass:$(PASSWORD_CLIENT)
	chmod g+r client.pem
	cp client.pem $(USER_NAME).pem

.PHONY: client.vrfy
client.vrfy: ca.pem client.pem
	c_rehash .
	$(OPENSSL) verify -CApath . client.pem

######################################################################
#
#  Create a new inner-server certificate, signed by the above CA.
#
######################################################################
inner-server.csr inner-server.key: inner-server.cnf
	$(OPENSSL) req -new  -out inner-server.csr -keyout inner-server.key -config ./inner-server.cnf
	chmod g+r inner-server.key

inner-server.crt: ca.key ca.pem inner-server.csr
	$(OPENSSL) ca -batch -keyfile ca.key -cert ca.pem -in inner-server.csr  -key $(PASSWORD_CA) -out inner-server.crt -extensions xpserver_ext -extfile xpextensions -config ./inner-server.cnf

inner-server.p12: inner-server.crt
	$(OPENSSL) pkcs12 -export -in inner-server.crt -inkey inner-server.key -out inner-server.p12  -passin pass:$(PASSWORD_INNER) -passout pass:$(PASSWORD_INNER)
	chmod g+r inner-server.p12

inner-server.pem: inner-server.p12
	$(OPENSSL) pkcs12 -in inner-server.p12 -out inner-server.pem -passin pass:$(PASSWORD_INNER) -passout pass:$(PASSWORD_INNER)
	chmod g+r inner-server.pem

.PHONY: inner-server.vrfy
inner-server.vrfy: ca.pem
	@$(OPENSSL) verify $(PARTIAL) -CAfile ca.pem inner-server.pem

######################################################################
#
#  Miscellaneous rules.
#
######################################################################
index.txt:
	@touch index.txt

serial:
	@echo '01' > serial

print:
	$(OPENSSL) x509 -text -in server.crt

printca:
	$(OPENSSL) x509 -text -in ca.pem

clean:
	@rm -f *~ *old client.csr client.key client.crt client.p12 client.pem

#
#	Make a target that people won't run too often.
#
destroycerts:
	rm -f *~ dh *.csr *.crt *.p12 *.der *.pem *.key index.txt* \
			serial*  *\.0 *\.1 ca-crl.pem ca.crl

=== src/modules/rlm_totp/Makefile ===
#
#  TOTP isn't simple, so we need test cases.
#
all: totp

include ../../../Make.inc

#
#  Hack up stuff so we can build in a subdirectory.
#
.PHONY: src
src:
	@ln -sf ../../../src

.PHONY: freeradius-devel
freeradius-devel:
	@ln -sf ../../../src/include freeradius-devel

#
#  ./totp decode <base32>
#
#  ./totp totp <time> <sha1key> <8-character-challenge>
#
totp: rlm_totp.c | src freeradius-devel
	@$(CC) -DTESTING $(CFLAGS) $(CPPFLAGS) $(OPENSSL_CPPFLAGS) -o $@ $(LDFLAGS) $(LIBS) ../../../build/lib/.libs/libfreeradius-radius.a rlm_totp.c

#
#  Test vectors from RFC 6238, Appendix B
#
test: totp
	@while IFS= read -r line; do \
		./totp totp $$line || exit 1; \
	done < sha1.txt

=== debian/control ===
Source: freeradius
Build-Depends: debhelper-compat (= 13),
               default-libmysqlclient-dev,
               freetds-dev,
               libcap-dev,
#		Temporarily disable due to collectd RC bugs
#               libcollectdclient-dev,
               libcurl4-openssl-dev | libcurl4-gnutls-dev,
               libgdbm-dev,
               libhiredis-dev,
               libiodbc2-dev,
               libjson-c-dev,
               libkrb5-dev | heimdal-dev,
               libldap2-dev,
               libmemcached-dev,
               libpam0g-dev,
               libpcap-dev,
               libperl-dev,
               libpq-dev,
               libreadline-dev,
               libsasl2-dev,
               libsqlite3-dev,
               libssl-dev,
               libsystemd-dev,
               libtalloc-dev,
               libwbclient-dev,
               libykclient-dev,
               libyubikey-dev,
               python3-dev,
               libwbclient-dev (>> 2:4.19.6+dfsg-2~),
               snmp
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian FreeRADIUS Packaging Team <pkg-freeradius-maintainers@lists.alioth.debian.org>
Uploaders: Mark Hymers <mhy@debian.org>,
           Sam Hartman <hartmans@debian.org>,
           Bernhard Schmidt <berni@debian.org>
Standards-Version: 4.6.2
Homepage: http://www.freeradius.org/
Vcs-Git: https://salsa.debian.org/debian/freeradius.git
Vcs-Browser: https://salsa.debian.org/debian/freeradius

Package: freeradius
Architecture: any
Depends: freeradius-common,
         freeradius-config,
         libfreeradius3 (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Provides: radius-server
Recommends: freeradius-utils
Suggests: freeradius-krb5,
          freeradius-ldap,
          freeradius-mysql,
          freeradius-postgresql,
          freeradius-python3,
          snmp
Description: high-performance and highly configurable RADIUS server
 FreeRADIUS is a high-performance RADIUS server with support for:
  - Authentication by local files, SQL, Kerberos, LDAP, PAM, and more.
  - Powerful policy configuration language.
  - Proxying and replicating requests by any criteria.
  - Support for many EAP types; TLS, PEAP, TTLS, etc.
  - Many vendor-specific attributes.
  - Regexp matching in string attributes.
 and lots more.

Package: freeradius-common
Depends: adduser, ${misc:Depends}
Architecture: all
Conflicts: radiusd-livingston, xtradius, yardradius
Description: FreeRADIUS common files
 This package contains common files used by several of the other packages from
 the FreeRADIUS project.

Package: freeradius-config
Architecture: any
Depends: adduser,
         ca-certificates,
         freeradius-common,
         make,
         openssl,
         ssl-cert,
         ${misc:Depends}
Breaks: freeradius-config
Description: FreeRADIUS default config files
 freeradius-config contains the default configuration for FreeRADIUS.
 .
 You can install a custom package which sets "Provides: freeradius-config" in
 order to use the FreeRADIUS packages without any default configuration getting
 into your way.

Package: freeradius-utils
Architecture: any
Conflicts: radiusd-livingston, yardradius
Depends: freeradius-common,
         freeradius-config,
         libfreeradius3 (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends}
Recommends: libdbi-perl
Description: FreeRADIUS client utilities
 This package contains various client programs and utilities from
 the FreeRADIUS Server project, including:
  - radclient
  - radcrypt
  - radeapclient
  - radlast
  - radsecret
  - radsniff
  - radsqlrelay
  - radtest
  - radwho
  - radzap
  - rlm_ippool_tool
  - smbencrypt

Package: libfreeradius3
Architecture: any
Section: libs
Depends: ${dist:Depends}, ${misc:Depends}, ${shlibs:Depends}
Description: FreeRADIUS shared library
 The FreeRADIUS projects' libfreeradius-radius and libfreeradius-eap, used by
 the FreeRADIUS server and some of the utilities.

Package: libfreeradius-dev
Architecture: any
Section: libdevel
Depends: freeradius-dhcp (= ${binary:Version}),
         libfreeradius3 (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: FreeRADIUS shared library development files
 The FreeRADIUS projects' libfreeradius-radius and libfreeradius-eap, used by
 the FreeRADIUS server and some of the utilities.
 .
 This package contains the development headers and static library version.

Package: freeradius-dhcp
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: DHCP module for FreeRADIUS server
 The FreeRADIUS server can act as a DHCP server, and this module
 is necessary for that.

Package: freeradius-krb5
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: kerberos module for FreeRADIUS server
 The FreeRADIUS server can use Kerberos to authenticate users, and this module
 is necessary for that.

Package: freeradius-ldap
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: LDAP module for FreeRADIUS server
 The FreeRADIUS server can use LDAP to authenticate users, and this module
 is necessary for that.

Package: freeradius-rest
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: REST module for FreeRADIUS server
 The FreeRADIUS server can make calls to remote web APIs, and this module
 is necessary for that.

Package: freeradius-postgresql
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: PostgreSQL module for FreeRADIUS server
 The FreeRADIUS server can use PostgreSQL to authenticate users and do
 accounting, and this module is necessary for that.

Package: freeradius-mysql
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: MySQL module for FreeRADIUS server
 The FreeRADIUS server can use MySQL to authenticate users and do accounting,
 and this module is necessary for that.

Package: freeradius-iodbc
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: iODBC module for FreeRADIUS server
 The FreeRADIUS server can use iODBC to access databases to authenticate users
 and do accounting, and this module is necessary for that.

Package: freeradius-redis
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: Redis module for FreeRADIUS server
 This module is required to enable the FreeRADIUS server to access
 Redis databases.

Package: freeradius-memcached
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: Memcached module for FreeRADIUS server
 The FreeRADIUS server can cache data in memcached and this package
 contains the required module.

Package: freeradius-yubikey
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: Yubikey module for FreeRADIUS server
 This package is required to add Yubikey functionality to the
 FreeRADIUS server.

Package: freeradius-python3
Architecture: any
Depends: freeradius (= ${binary:Version}),
         ${dist:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: Python 3 module for FreeRADIUS server
 This package is required to add Python 3 functionality to the
 FreeRADIUS server.
 .
 It was introduced in FreeRADIUS 3.0.20 as EXPERIMENTAL module. Use at
 your own risk.

## freeradius 3.2.7+dfsg

=== Makefile ===
#
#  Makefile
#
#		NOTE: This top-level Makefile must not
#		use GNU-make extensions. The lower ones can.
#
#  Version:	$Id: 888e74e14f0c371788f74309093b0c2d9e12bf34 $
#

#
#  If we didn't call ./configure just define the version.
#
RADIUSD_VERSION_STRING := $(shell cat VERSION)

#
#  The default rule is "all".
#
all:

#
#  Catch people who try to use BSD make
#
ifeq "0" "1"
.error GNU Make is required to build FreeRADIUS
endif

#
#  We require Make.inc, UNLESS the target is "make deb"
#
#  Since "make deb" re-runs configure... there's no point in
#  requiring the developer to run configure *before* making
#  the debian packages.
#
ifneq "$(MAKECMDGOALS)" "deb"
ifneq "$(MAKECMDGOALS)" "rpm"
ifeq "$(findstring docker,$(MAKECMDGOALS))" ""
ifeq "$(findstring crossbuild,$(MAKECMDGOALS))" ""
$(if $(wildcard Make.inc),,$(error Missing 'Make.inc' Run './configure [options]' and retry))

include Make.inc
endif
endif
endif
endif

MFLAGS += --no-print-directory

#
#  The version of GNU Make is too old, don't use it (.FEATURES
#  variable was added in 3.81)
#
ifndef .FEATURES
$(error The build system requires GNU Make 3.81 or later.)
endif

export DESTDIR := $(R)

#
#  And over-ride all of the other magic.
#
ifneq "$(MAKECMDGOALS)" "deb"
ifneq "$(MAKECMDGOALS)" "rpm"
ifeq "$(findstring docker,$(MAKECMDGOALS))" ""
ifeq "$(findstring crossbuild,$(MAKECMDGOALS))" ""
include scripts/boiler.mk
endif
endif
endif
endif

#
#  To work around OpenSSL issues within CI.
#
.PHONY:
raddb/test.conf:
	@echo 'security {' >> $@
	@echo '        allow_vulnerable_openssl = yes' >> $@
	@echo '}' >> $@
	@echo '$$INCLUDE radiusd.conf' >> $@

#
#  Run "radiusd -C", looking for errors.
#
#  Only redirect STDOUT, which should contain details of why the test failed.
#  Don't molest STDERR as this may be used to receive output from a debugger.
#
$(BUILD_DIR)/tests/radiusd-c: raddb/test.conf ${BUILD_DIR}/bin/radiusd | build.raddb
	${Q}$(MAKE) -C raddb/certs
	${Q}printf "radiusd -C... "
	${Q}if ! $(TESTBIN)/radiusd -XCMd ./raddb -D ./share -n test > $(BUILD_DIR)/tests/radiusd.config.log; then \
		rm -f raddb/test.conf; \
		cat $(BUILD_DIR)/tests/radiusd.config.log; \
		echo "fail"; \
		exit 1; \
	fi
	${Q}rm -f raddb/test.conf
	${Q}echo "ok"
	${Q}touch $@

test: ${BUILD_DIR}/bin/radiusd ${BUILD_DIR}/bin/radclient tests.unit tests.xlat tests.keywords tests.modules tests.auth test.sql_nas_table $(BUILD_DIR)/tests/radiusd-c | build.raddb
	${Q}$(MAKE) -C src/tests tests

#
#  Tests specifically for CI. We do a LOT more than just
#  the above tests
#
ci-test: raddb/test.conf test
	${Q}$(TESTBIN)/radiusd -xxxv -n test
	${Q}rm -f raddb/test.conf
	${Q}$(MAKE) install
	${Q}perl -p -i -e 's/allow_vulnerable_openssl = no/allow_vulnerable_openssl = yes/' ${raddbdir}/radiusd.conf
	${Q}sh ${HOME}/freeradius/etc/raddb/certs
	${Q}${sbindir}/radiusd -XC

#
#  The $(R) is a magic variable not defined anywhere in this source.
#  It's purpose is to allow an admin to create an installation 'tar'
#  file *without* actually installing it.  e.g.:
#
#  $ R=/home/root/tmp make install
#  $ cd /home/root/tmp
#  $ tar -cf ~/freeradius-package.tar *
#
#  The 'tar' file can then be un-tar'd on any similar machine.  It's a
#  cheap way of creating packages, without using a package manager.
#  Many of the platform-specific packaging tools use the $(R) variable
#  when creating their packages.
#
#  For compatibility with typical GNU packages (e.g. as seen in libltdl),
#  we make sure DESTDIR is defined.
#
export DESTDIR := $(R)

DICTIONARIES := $(wildcard share/dictionary*)
install.share: $(addprefix $(R)$(dictdir)/,$(notdir $(DICTIONARIES)))

.PHONY: dictionary.format
dictionary.format: $(DICTIONARIES)
	${Q}./share/format.pl $(DICTIONARIES)

$(R)$(dictdir)/%: share/%
	@echo INSTALL $(notdir $<)
	${Q}$(INSTALL) -m 644 $< $@

MANFILES := $(filter-out $(MANSKIP),$(wildcard man/man*/*.?))
MANDIR   := $(wildcard man/man*)
install.man: $(subst man/,$(R)$(mandir)/,$(MANFILES))

$(MANDIR):
	${Q}echo INSTALL $(patsubst $(R)$(mandir)/%,man/%,$@)
	${Q}$(INSTALL) -d -m 755 $@

$(R)$(mandir)/%: man/% | $(dir $@)
	${Q}echo INSTALL $(notdir $<)
	${Q}sed -e "s,/etc/raddb,$(raddbdir),g" \
		-e "s,/usr/local/share,$(datarootdir),g" \
		$< > $<.subst
	${Q}$(INSTALL) -m 644 $<.subst $@
	${Q}rm $<.subst

#
#  Don't install rlm_test
#
ALL_INSTALL := $(patsubst %rlm_test.la,,$(ALL_INSTALL))

install: install.share install.man
	${Q}$(INSTALL) -d -m 700	$(R)$(logdir)
	${Q}$(INSTALL) -d -m 700	$(R)$(radacctdir)

ifneq ($(RADMIN),)
ifneq ($(RGROUP),)
.PHONY: install-chown
install-chown:
	chown -R $(RADMIN)   $(R)$(raddbdir)
	chgrp -R $(RGROUP)   $(R)$(raddbdir)
	chmod u=rwx,g=rx,o=  `find $(R)$(raddbdir) -type d -print`
	chmod u=rw,g=r,o=    `find $(R)$(raddbdir) -type f -print`
	chown -R $(RADMIN)   $(R)$(logdir)
	chgrp -R $(RGROUP)   $(R)$(logdir)
	find $(R)$(logdir) -type d -exec chmod u=rwx,g=rwx,o= {} \;
	find $(R)$(logdir) -type d -exec chmod g+s {} \;
	find $(R)$(logdir) -type f -exec chmod u=rw,g=rw,o= {} \;
	chown -R $(RADMIN)   $(R)$(RUNDIR)
	chgrp -R $(RGROUP)   $(R)$(RUNDIR)
	find $(R)$(RUNDIR) -type d -exec chmod u=rwx,g=rwx,o= {} \;
	find $(R)$(RUNDIR) -type d -exec chmod g+s {} \;
	find $(R)$(RUNDIR) -type f -exec chmod u=rw,g=rw,o= {} \;
endif
endif

distclean: clean
	@-find src/modules -regex .\*/config[.][^.]*\$$ -delete
	@-find src/modules -name autom4te.cache -exec rm -rf '{}' \;
	@rm -rf config.cache config.log config.status libtool \
		src/include/radpaths.h src/include/stamp-h \
		libltdl/config.log libltdl/config.status \
		libltdl/libtool autom4te.cache build
	@-find . ! -name configure.ac -name \*.in -print | \
		sed 's/\.in$$//' | \
		while read file; do rm -f $$file; done

######################################################################
#
#  Automatic remaking rules suggested by info:autoconf#Automatic_Remaking
#
######################################################################
#
#  Do these checks ONLY if we're re-building the "configure"
#  scripts, and ONLY the "configure" scripts.  If we leave
#  these rules enabled by default, then they're run too often.
#
ifeq "$(MAKECMDGOALS)" "reconfig"

CONFIGURE_AC_FILES := $(shell find . -name configure.ac -print)
CONFIGURE_FILES	   := $(patsubst %.ac,%,$(CONFIGURE_AC_FILES))

#
#  The GNU tools make autoconf=="missing autoconf", which then returns
#  0, even when autoconf doesn't exist.  This check is to ensure that
#  we run AUTOCONF only when it exists.
#
AUTOCONF_EXISTS := $(shell autoconf --version 2>/dev/null)

ifeq "$(AUTOCONF_EXISTS)" ""
$(error You need to install autoconf to re-build the "configure" scripts)
endif

#  Configure files depend on ".ac" files, and on the top-level macro files
#  If there are headers, run auto-header, too.
src/%configure: src/%configure.ac acinclude.m4 aclocal.m4 $(wildcard $(dir $@)m4/*m4) | src/freeradius-devel
	@echo AUTOCONF $(dir $@)
	${Q}cd $(dir $@) && \
		$(ACLOCAL) --force -I $(top_builddir) -I $(top_builddir)/m4 && \
		$(AUTOCONF) --force
	${Q}if grep AC_CONFIG_HEADERS $@ >/dev/null; then\
		echo AUTOHEADER $@ \
		cd $(dir $@) && $(AUTOHEADER) --force; \
	 fi

#  "%configure" doesn't match "configure"
configure: configure.ac $(wildcard ac*.m4) $(wildcard m4/*.m4)
	@echo AUTOCONF $@
	@$(ACLOCAL) --force
	@$(AUTOCONF) --force

src/include/autoconf.h.in: configure.ac
	@echo AUTOHEADER $@
	@$(AUTOHEADER) --force

reconfig: $(CONFIGURE_FILES) src/include/autoconf.h.in

config.status: configure
	./config.status --recheck

#  target is "reconfig"
endif

#
#  If we've already run configure, then add rules which cause the
#  module-specific "all.mk" files to depend on the mk.in files, and on
#  the configure script.
#
ifneq "$(wildcard config.log)" ""
CONFIGURE_ARGS	   := $(shell head -10 config.log | grep '^  \$$' | sed 's/^....//;s:.*configure ::')

src/%all.mk: src/%all.mk.in src/%configure
	${Q}echo CONFIGURE $(dir $@)
	${Q}rm -f ./config.cache $(dir $<)/config.cache
	${Q}cd $(dir $<) && ./configure $(CONFIGURE_ARGS) && touch $(notdir $@)
endif

.PHONY: check-includes
check-includes:
	scripts/min-includes.pl `find . -name "*.c" -print`

.PHONY: TAGS
TAGS:
	etags `find src -type f -name '*.[ch]' -print` > $@

#
#  Make test certificates.
#
.PHONY: certs
certs:
	${Q}$(MAKE) -C raddb/certs

######################################################################
#
#  Make a release.
#
#  Note that "Make.inc" has to be updated with the release number
#  BEFORE running this command!
#
######################################################################
BRANCH = $(shell git rev-parse --abbrev-ref HEAD)

freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz: .git/HEAD
	git archive --format=tar --prefix=freeradius-server-$(RADIUSD_VERSION_STRING)/ $(BRANCH) | gzip > $@

freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2: .git/HEAD
	git archive --format=tar --prefix=freeradius-server-$(RADIUSD_VERSION_STRING)/ $(BRANCH) | bzip2 > $@

%.sig: %
	gpg --local-user packages@freeradius.org -b $<

#
#  High-level targets
#
.PHONY: dist-check
dist-check: redhat/freeradius.spec suse/freeradius.spec debian/changelog
	${Q}if [ `grep ^Version: redhat/freeradius.spec | sed 's/.*://;s/ //g'` != "$(RADIUSD_VERSION_STRING)" ]; then \
		cat redhat/freeradius.spec | sed 's/^Version:.*/Version: $(RADIUSD_VERSION_STRING)/' > redhat/.foo; \
		mv redhat/.foo redhat/freeradius.spec; \
		echo redhat/freeradius.spec 'Version' needs to be updated; \
		exit 1; \
	fi
	${Q}if [ `grep ^Version: suse/freeradius.spec | sed 's/.*://;s/ //g'` != "$(RADIUSD_VERSION_STRING)" ]; then \
		cat suse/freeradius.spec | sed 's/^Version: .*/Version:      $(RADIUSD_VERSION_STRING)/' > suse/.foo; \
		mv suse/.foo suse/freeradius.spec; \
		echo suse/freeradius.spec 'Version' needs to be updated; \
		exit 1; \
	fi
	${Q}if [ `head -n 1 doc/ChangeLog | awk '/^FreeRADIUS/{print $$2}'` != "$(RADIUSD_VERSION_STRING)" ]; then \
		echo doc/ChangeLog needs to be updated; \
		exit 1; \
	fi
	${Q}if [ `head -n 1 debian/changelog | sed 's/.*(//;s/-0).*//;s/-1).*//;s/\+.*//'` != "$(RADIUSD_VERSION_STRING)" ]; then \
		echo debian/changelog needs to be updated; \
		exit 1; \
	fi
	${Q}if [ `grep version doc/antora/antora.yml | sed 's/^.*version: //'` != "'$(RADIUSD_VERSION_STRING)'" ]; then \
		echo doc/antora/antora.yml needs to be updated with: version '$(RADIUSD_VERSION_STRING)'; \
		exit 1; \
	fi

dist: dist-check freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2

dist-sign: dist-check freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz.sig freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2.sig

dist-publish: freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz.sig freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz.sig freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2 freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz.sig freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2.sig
	scp $^ freeradius.org@ftp.freeradius.org:public_ftp

#
#  Note that we do NOT do the tagging here!  We just print out what
#  to do!
#
dist-tag: freeradius-server-$(RADIUSD_VERSION_STRING).tar.gz freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2
	${Q}echo "git tag release_`echo $(RADIUSD_VERSION_STRING) | tr .- __`"

#
#  Docker-related targets (main Docker images and crossbuild)
#
ifneq "$(findstring docker,$(MAKECMDGOALS))" ""
include scripts/docker/docker.mk
endif

ifneq "$(findstring crossbuild,$(MAKECMDGOALS))" ""
include scripts/crossbuild/crossbuild.mk
endif

#
#  Build a Debian package
#
DEBBUILDEXTRA = --jobs=auto
.PHONY: deb
deb:
	fakeroot debian/rules debian/control #clean
	fakeroot dpkg-buildpackage $(DEBBUILDEXTRA) -b -uc

#
#  Build an RPM package
#
.PHONY: rpm
rpmbuild/SOURCES/freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2: freeradius-server-$(RADIUSD_VERSION_STRING).tar.bz2
	${Q}mkdir -p $(addprefix rpmbuild/,SOURCES SPECS BUILD RPMS SRPMS BUILDROOT)

=== debian/changelog ===
freeradius (3.2.7+dfsg-1+deb13u1) trixie; urgency=medium

  * Non-maintainer upload.
  * Backport patch to fix compatibility with OpenSSL 3.5.2 (Closes: #1111328)

 -- Sebastian Andrzej Siewior <sebastian@breakpoint.cc>  Wed, 01 Oct 2025 19:36:38 +0200

freeradius (3.2.7+dfsg-1) unstable; urgency=medium

  * New upstream version 3.2.7+dfsg
    - add new module rlm_proxy_rate_limit.so
    - force building the radlast wrapper script although there currently
      is no "last" implementation in Debian capable to read the old
      wtmp format. Add d/NEWS.Debian to document this.
  * Revert "freeradius-utils: add wtmpdb needed for radlast"
  * Add mariadb dependency to obsolete init script (Closes: #1059490)
  * Remove obsolete files d/README.source and d/freeradius.NEWS
  * Refresh upstream signing key

 -- Bernhard Schmidt <berni@debian.org>  Mon, 10 Feb 2025 22:50:22 +0100

=== debian/control ===
--- 
+++ 
@@ -31,8 +31,7 @@
                snmp
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian FreeRADIUS Packaging Team <pkg-freeradius-maintainers@lists.alioth.debian.org>
+Maintainer: Debian FreeRADIUS Packaging Team <pkg-freeradius-maintainers@lists.alioth.debian.org>
 Uploaders: Mark Hymers <mhy@debian.org>,
            Sam Hartman <hartmans@debian.org>,
            Bernhard Schmidt <berni@debian.org>

=== debian/watch ===
version=3

opts=pasv,\
pgpsigurlmangle=s/$/.sig/,\
repacksuffix=+dfsg,\
dversionmangle=s/\+(git$|dfsg)//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/\
  ftp://ftp.freeradius.org/pub/freeradius/freeradius-server-(3\.2\..+)\.tar\.gz

## freeradius 3.2.8+dfsg

=== src/tests/Makefile ===
# -*- makefile -*-
##
## Makefile -- Build and run tests for the server.
##
##	http://www.freeradius.org/
##	$Id: 3fba18c11c66f084de91b783f8f5a0e660a5b66f $
##
#
include ../../Make.inc

#
#  You can watch what it's doing by:
#
#	$ VERBOSE=1 make ... args ...
#
ifeq "${VERBOSE}" ""
    Q=@
else
    Q=
endif

BUILD_PATH := $(top_builddir)/build

#
#  Build eapol_test if requested to.
#
.PHONY: eapol_test
eapol_test: $(BUILD_PATH)/tests/eapol_test/eapol_test.mk
	${Q}echo EAPOL_TEST=$(EAPOL_TEST)

#
#  If we're doing anything resembling EAP, then make sure that
#  EAPOL_TEST is defined.
#
ifneq "(findstring eap,$(MAKECMDGOALS))" ""
$(BUILD_PATH)/tests/eapol_test:
	${Q}mkdir -p $@

TEST_PATH := $(top_builddir)/src/tests
DICT_PATH := $(TEST_PATH)
BIN_PATH := $(BUILD_PATH)/bin/local
RADIUSD_BIN := $(BIN_PATH)/radiusd

ifeq "$(DICT_PATH)" "$(TEST_PATH)"
LIB_PATH := $(BUILD_PATH)/lib/local/.libs/
DYLD_LIBRARY_PATH := $(DYLD_LIBRARY_PATH):$(LIB_PATH)
export DYLD_LIBRARY_PATH
endif

ifneq "$(OPENSSL_LIBS)" ""
#
#  Build eapol_test, and cache its output.  Note that EAPOL_TEST may not be
#  defined, so we have to run the shell script for the second line, too.
#
#  Normal expansion will still run the script if EAPOL_TEST_BIN is
#  set but empty, which we don't want.
#
ifeq "$(EAPOL_TEST_BIN)" ""
override EAPOL_TEST_BIN := $(shell $(top_builddir)/scripts/ci/eapol_test-build.sh)
endif

$(BUILD_PATH)/tests/eapol_test/eapol_test.mk: | $(BUILD_PATH)/tests/eapol_test
	${Q}echo "EAPOL_TEST=$(EAPOL_TEST_BIN)" > $@
	${Q}echo "TLS1_3=$(shell openssl ciphers -s -v 'ECDHE:!COMPLEMENTOFDEFAULT'| grep -q 'TLSv1.3' && echo yes)" >> $@
	${Q}echo "OPENSSL_OK=$(shell openssl version | grep -v ' 1\.0' >/dev/null && echo yes)" >> $@
	${Q}echo "OPENSSL3_OK=$(shell openssl version | grep -q ' OpenSSL 3\.0' && echo yes)" >> $@
else
#
#  No OpenSSL means that we don't even try to build eapol_test
#
.PHONY: $(BUILD_PATH)/tests/eapol_test/eapol_test.mk
$(BUILD_PATH)/tests/eapol_test/eapol_test.mk: | $(BUILD_PATH)/tests/eapol_test
	${Q}touch $@
endif

-include $(BUILD_PATH)/tests/eapol_test/eapol_test.mk
endif

#
#  OpenSSL 1.0.x doesn't support cipher_list="DEFAULT@SECLEVEL=1"
#
#  If the variable is empty, then OpenSSL isn't OK.
#
ifeq "$(OPENSSL_OK)" ""
SECLEVEL=
else
SECLEVEL=@SECLEVEL=1
endif

#
#  For OpenSSL 3.0.x, as described in https://github.com/openssl/openssl/blob/master/doc/man7/migration_guide.pod
#
#  "The security strength of SHA1 and MD5 based signatures in TLS has been reduced.
#   This results in SSL 3, TLS 1.0, TLS 1.1 and DTLS 1.0 no longer working at the
#   default security level of 1 and instead requires security level 0."
#
ifeq "$(OPENSSL3_OK)" "yes"
SECLEVEL=@SECLEVEL=0
endif

RADDB_PATH := $(top_builddir)/raddb/

TESTS	= mschapv1 digest-01/digest* \
	test.example.com

PORT	 = 12340
ACCTPORT = $(shell expr $(PORT) + 1)

#	example.com stripped.example.com

SECRET	= testing123

.PHONY: all eap dictionary clean

#
#	Build the directory for testing the server
#
all: tests

clean:
	@rm -f test.conf dictionary *.ok *.log $(BUILD_DIR)/tests/eap

dictionary:
	@echo "# test dictionary. Do not install.  Delete at any time." > dictionary;  \
	echo '$$INCLUDE ' $(top_builddir)/share/dictionary >> dictionary;          \
	echo '$$INCLUDE ' $(top_builddir)/src/tests/dictionary.test >> dictionary; \
	if [ "$(DICT_PATH)" = "$(TEST_PATH)" ]; then                               \
	    echo '$$INCLUDE ' $(top_builddir)/share/dictionary.dhcp >> dictionary; \
	    echo '$$INCLUDE ' $(top_builddir)/share/dictionary.vqp >> dictionary;  \
	fi

test.conf: dictionary config/eap-test
	@echo "# test configuration file.  Do not install.  Delete at any time." > $@
	${Q}if [ -n "$(LIB_PATH)" ]; then  \
	    echo "libdir =" $(LIB_PATH) >> $@; \
	fi
	${Q}echo "testdir =" $(TEST_PATH) >> $@
	${Q}echo 'logdir = $${testdir}' >> $@
	${Q}echo "maindir =" $(RADDB_PATH) >> $@
	${Q}echo 'radacctdir = $${testdir}' >> $@
	${Q}echo 'pidfile = $${testdir}/radiusd.pid' >> $@
	${Q}echo 'panic_action = "gdb -batch -x $${testdir}/panic.gdb %e %p > $${testdir}/gdb.log 2>&1; cat $${testdir}/gdb.log"' >> $@
	${Q}echo 'security {' >> $@
	${Q}echo '        allow_vulnerable_openssl = yes' >> $@
	${Q}echo '}' >> $@
	${Q}echo >> $@
	${Q}echo 'modconfdir = $${maindir}mods-config' >> $@
	${Q}echo 'certdir = $${maindir}/certs' >> $@
	${Q}echo 'cadir   = $${maindir}/certs' >> $@
	${Q}echo '$$INCLUDE $${testdir}/config/' >> $@
	${Q}echo '$$INCLUDE $${maindir}/radiusd.conf' >> $@

#
#  Rename "inner-tunnel", and ensure that it only uses the "eap-test" module.
#
config/eap-test-inner-tunnel: $(RADDB_PATH)sites-available/inner-tunnel
	${Q}sed 's/eap/eap-test/;s/server inner-tunnel/server eap-test-inner-tunnel/' < $< > $@

#
#  * Same renames as above
#  * enable caching
#  * uncomment caching directory
#  * set the minimum TLS version to 1.0 for testing
#  * set the maximum TLS version to 1.2 or 1.3, depending if 1.3 is available
#  * always enable TLS 1.3 for the tests, via the super-secret magic flag.
#  * tell OpenSSL to enable insecure ciphers TLS 1.0 and TLS 1.1
#
config/eap-test: $(RADDB_PATH)mods-available/eap config/eap-test-inner-tunnel
	${Q}sed -e 's/eap {/eap eap-test {/' \
	     -e 's/= inner-tunnel/= eap-test-inner-tunnel/;s/use_tunneled_reply = no/use_tunneled_reply = yes/' \
	     -e 's/enable = no/enable = yes/' \
	     -e 's/^\(.*\)persist_dir =/  persist_dir =/' \
	     -e 's/#.*softfail =.*/softfail = yes/' \
	     -e 's/tls_min_version = "1.2"/tls_min_version = "1.0"/' \
	     -e '$(if $(TLS1_3),s/tls_max_version = "1.2"/tls_max_version = "1.3"/)' \
	     -e 's/cipher_list = "DEFAULT"/cipher_list = "DEFAULT${SECLEVEL}"/' \
		 < $< > $@

radiusd.pid: test.conf
	${Q}rm -rf $(TEST_PATH)/gdb.log $(TEST_PATH)/radius.log $(TEST_PATH)/tlscache
	${Q}mkdir -p $(TEST_PATH)/tlscache
	${Q}printf "Starting server... "
	${Q}if ! $(RADIUSD_BIN) -Pxxxxml $(TEST_PATH)/radius.log -d ${top_builddir}/src/tests -n test -i 127.0.0.1 -p $(PORT) -D $(DICT_PATH); then \
		echo "failed"; \
		echo "Last log entries were:"; \
		tail -n 20 "$(TEST_PATH)/radius.log"; \
	fi
	${Q}echo "ok"
	${Q}echo "radiusd logging to $(TEST_PATH)/radius.log"

# We can't make this depend on radiusd.pid, because then make will create
# radiusd.pid when we make radiusd.kill, which we don't want.
.PHONY: radiusd.kill
radiusd.kill:
	${Q}if [ -f radiusd.pid ]; then \
	    ret=0; \
	    if ! ps `cat $(TEST_PATH)/radiusd.pid` >/dev/null 2>&1; then \
		rm -f radiusd.pid; \
		echo "FreeRADIUS terminated during test"; \
		echo "GDB output was:"; \
		cat "$(TEST_PATH)/gdb.log"; \
		echo "Last log entries were:"; \
		tail -n 20 $(TEST_PATH)/radius.log; \
		ret=1; \
	    fi; \
		if ! kill -TERM `cat $(TEST_PATH)/radiusd.pid` >/dev/null 2>&1; then \
		    ret=1; \
		fi; \
		exit $$ret; \
	fi
	${Q}rm -f radiusd.pid

#
#  Run eapol_test if it exists and we built with openssl support.
#  Otherwise do nothing.
#
ifneq "$(EAPOL_TEST)" ""
EAP_FILES        = eap-md5.conf
EAP_FILES       += eap-mschapv2.conf

EAP_TLS_FILES    = eap-tls.conf
EAP_TLS_FILES   += eap-ttls-eap-gtc.conf
EAP_TLS_FILES   += eap-ttls-eap-mschapv2.conf
EAP_TLS_FILES   += eap-ttls-eap-tls.conf
EAP_TLS_FILES   += eap-ttls-mschapv2.conf
EAP_TLS_FILES   += eap-ttls-pap.conf
EAP_TLS_FILES   += peap-client-mschapv2.conf
EAP_TLS_FILES   += peap-eap-tls.conf
EAP_TLS_FILES   += peap-gtc.conf
EAP_TLS_FILES   += peap-mschapv2.conf

#EAP_TLS_FILES   += eap-fast.conf		# disabled in default config
#EAP_TLS_FILES   += eap-pwd.conf		# disabled in default config
#EAP_TLS_FILES   += eap-teap-mschapv2.conf	# not configured in eapol_test

EAP_TLS_VERSIONS = 1.1 1.2
EAP_TLS_DISABLE_STRING = tls_disable_tlsv1_0=1 tls_disable_tlsv1_1=1 tls_disable_tlsv1_2=1

ifneq "$(TLS1_3)" ""
EAP_TLS_VERSIONS       += 1.3
EAP_TLS_DISABLE_STRING += tls_disable_tlsv1_3=1
endif

.PHONY: $(BUILD_PATH)/tests/eap
$(BUILD_PATH)/tests/eap:
	${Q}mkdir -p $@

.PHONY: clean.tests.eap
clean.tests.eap:
	${Q}rm -rf $(BUILD_PATH)/tests/eap config/tlscache config/eap-test config/eap-test-inner-tunnel

#
#  Set target-specific variables, so that the later shell scripts are rather more understandable.
#
#  MD5 doesn't use MPPE keys
#
$(BUILD_PATH)/tests/eap/%.ok: NO_MPPE = $(filter eap-md5,$(basename $(notdir $@)))
$(BUILD_PATH)/tests/eap/%.ok: CMD =  $(EAPOL_TEST) -c $< -p $(PORT) -s $(SECRET) $(if $(NO_MPPE),-n)
$(BUILD_PATH)/tests/eap/%.ok: LOG =  $(patsubst %.ok,%,$@).log

$(BUILD_PATH)/tests/eap/%.ok: $(top_builddir)/src/tests/%.conf | radiusd.kill $(BUILD_PATH)/tests/eap radiusd.pid radiusd.kill
	${Q}printf 'EAPOL_TEST %s ' $(notdir $(patsubst %.conf,%,$<))
	${Q}if ! $(CMD) > $(LOG) 2>&1; then \
		echo " - " FAILED - command failed; \
		echo ">>> cmd -" $(CMD); \
		echo ">>> log -" $(LOG); \
		echo "===================="; \
		tail -10 $(LOG); \
		echo "===================="; \
		$(MAKE) radiusd.kill; \
		exit 1; \
	fi
	@echo
	${Q}touch $@

#
#  Don't run the full TLS version tests for CI post-install.
#
ifneq "$(prefix)" ""
#
#  ${1} is the config file
#  ${2} is the TLS version to use.
#
#  Update the phase1 configuration to enable/disable various TLS versions
#  insert an OpenSSL cipher configuration line by cloning "password" and editing it.
#
define EAP_TLS_CONFIG
$(BUILD_PATH)/tests/eap/${1}-${2}.conf: $(top_builddir)/src/tests/${1}.conf
	${Q}sed -e 's/phase1="/phase1="$(subst $(subst .,_,${2})=1,$(subst .,_,${2})=0,$(EAP_TLS_DISABLE_STRING)) /' \
	     -e  '/password/s/^//p; /password/s/^.*/        openssl_ciphers="DEFAULT${SECLEVEL}"/' \
		< $$< > $$@

$(BUILD_PATH)/tests/eap/${1}-${2}.ok: $(BUILD_PATH)/tests/eap/${1}-${2}.conf
	${Q}printf 'EAPOL_TEST %s' $$(notdir $$(patsubst %.ok,%,$$@))
	${Q}if ! $$(CMD) -r 1 > $$(LOG) 2>&1; then \
		echo " - " FAILED  - command failed; \
		echo ">>> cmd -" $$(CMD) -r 1; \
		echo ">>> log -" $$(LOG); \
		echo "===================="; \
		tail -10 $$(LOG); \
		echo "===================="; \
		$(MAKE) radiusd.kill; \
		exit 1; \
	elif ! grep -q '^SSL: Using TLS version TLSv${2}$$$$' $$(patsubst %.ok,%,$$@).log; then \
		echo " - " FAILED - not using TLS version ${2}; \
		echo ">>> cmd -" $$(CMD) -r 1; \
		echo ">>> log -" $$(LOG); \
		$(MAKE) radiusd.kill; \
		exit 1; \
	elif ! grep -q '^OpenSSL: Handshake finished - resumed=1$$$$' $$(patsubst %.ok,%,$$@).log; then \
		echo " - " FAILED - did not use resumption; \
		echo ">>> cmd -" $$(CMD) -r 1; \
		echo ">>> log -" $$(LOG); \
		$(MAKE) radiusd.kill; \
		exit 1; \
	fi
	@echo
	${Q}touch $$@

# EAP-FAST doesn't do TLS 1.3
ifneq "${1}-${2}" "eap-fast-1.3"
EAP_TLS_VERSION_FILES += $(BUILD_PATH)/tests/eap/${1}-${2}.ok
endif
endef

$(foreach FILE,$(patsubst %.conf,%,$(EAP_TLS_FILES)),$(foreach TLS,$(EAP_TLS_VERSIONS),$(eval $(call EAP_TLS_CONFIG,${FILE},${TLS}))))
endif # there's no "prefix", so we don't run the full EAP tests

EAPOL_OK_FILES := $(sort $(addprefix $(BUILD_PATH)/tests/eap/,$(patsubst %.conf,%.ok, $(notdir $(EAP_TLS_FILES) $(EAP_FILES)))) $(EAP_TLS_VERSION_FILES))

tests.eap: $(EAPOL_OK_FILES) | radiusd.kill radiusd.pid
else
tests.eap:
	${Q}echo "EAP tests are disabled"
endif # we have eapol_test built

# kill the server (if it's running)
# start the server
# run the tests (ignoring any failures)
# kill the server
# remove the changes to raddb/
tests.runtests:  test.conf | radiusd.kill radiusd.pid
	${Q}chmod a+x runtests.sh
	${Q}BIN_PATH="$(BIN_PATH)" PORT="$(PORT)" ./runtests.sh $(TESTS)

tests: tests.runtests tests.eap
	$(MAKE) radiusd.kill

=== debian/changelog ===
freeradius (3.2.8+dfsg-1) unstable; urgency=medium

  * Update d/watch to use https instead of ftp
  * New upstream version 3.2.8+dfsg
    - Remove OpenSSL 3.5.2 patch applied upstream
    - Refresh patch for new upstream version
  * Remove Mark Hymers from Uploaders (Closes: #1107171)
  * d/salsa-ci.yml:
    - enable licenserecon, with allow_failure for now
    - disable superflous allow_failure statements
  * Adjust d/copyright

 -- Bernhard Schmidt <berni@debian.org>  Thu, 28 Aug 2025 01:09:38 +0200

freeradius (3.2.7+dfsg-2) unstable; urgency=high

  * Team upload.
  * Backport patch to fix compatibility with OpenSSL 3.5.2 (Closes:
    #1111328)

 -- Luca Boccassi <bluca@debian.org>  Thu, 21 Aug 2025 13:06:02 +0100

=== debian/control ===
--- 
+++ 
@@ -32,8 +32,7 @@
 Section: net
 Priority: optional
 Maintainer: Debian FreeRADIUS Packaging Team <pkg-freeradius-maintainers@lists.alioth.debian.org>
-Uploaders: Mark Hymers <mhy@debian.org>,
-           Sam Hartman <hartmans@debian.org>,
+Uploaders: Sam Hartman <hartmans@debian.org>,
            Bernhard Schmidt <berni@debian.org>
 Standards-Version: 4.6.2
 Homepage: http://www.freeradius.org/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       MAKEFLAGS += -j$(NUMJOBS)
endif

override_dh_auto_clean:
	[ ! -f Make.inc ] || dh_auto_clean

override_dh_auto_build:
	# dh_auto_install does both, compilation and installation.

override_dh_auto_install:
	VERBOSE=1 $(MAKE) install R=debian/tmp PACKAGE='debian'

override_dh_auto_test:
	# TODO: enable testing

override_dh_install:
	mv debian/tmp/usr/sbin/radiusd debian/tmp/usr/sbin/freeradius
	mv debian/tmp/usr/share/man/man8/radiusd.8 debian/tmp/usr/share/man/man8/freeradius.8
	# Not installed as we do not install the dhcpclient binary as per
	# https://github.com/FreeRADIUS/freeradius-server/issues/1734#issuecomment-247848277
	rm debian/tmp/usr/share/man/man1/dhcpclient.1
	# Remove all libtool .la files, as per
	# https://wiki.debian.org/ReleaseGoals/LAFileRemoval
	find debian/tmp/usr/lib/freeradius -name "*.la" -delete
	# Remove all plugin .a files (unnecessary), keep libfreeradius .a files
	# for end-users who want to statically link against libfreeradius.
	find debian/tmp/usr/lib/freeradius -name "*.a" -and \! -name "libfreeradius-*.a" -delete
	# We create the {mods,sites}-enabled links in freeradius-config.postinst
	# so that they are not re-created when users upgrade to a newer version.
	rm debian/tmp/etc/freeradius/3.0/mods-enabled/*
	rm debian/tmp/etc/freeradius/3.0/sites-enabled/*
	dh_install

override_dh_installpam:
	dh_installpam --name=radiusd

override_dh_installinit:
	dh_installinit --noscripts

override_dh_compress:
	dh_compress -Xexamples

override_dh_installdocs:
	dh_installdocs -Xdebian/tmp/usr/share/doc/freeradius/ChangeLog

override_dh_gencontrol:
	dh_gencontrol -- $(SUBSTVARS)

override_dh_auto_configure:
	dh_auto_configure -- $(confflags) \
		--config-cache \
		--disable-developer \
		--disable-openssl-version-check \
		--exec-prefix=/usr \
		--libdir=/usr/lib/freeradius \
		--datadir=/usr/share \
		--with-raddbdir=/etc/freeradius/3.0 \
		--with-logdir=/var/log/freeradius \
		--with-large-files \
		--with-udpfromto \
		--without-rlm_eap_tnc \
		--with-rlm_sql_postgresql_lib_dir=`pg_config --libdir` \
		--with-rlm_sql_postgresql_include_dir=`pg_config --includedir` \
		--with-iodbc-include-dir='/usr/include/iodbc' \
		--with-modules=rlm_python3 \
		--without-rlm_eap_ikev2 \
		--without-rlm_sql_oracle \
		--without-rlm_sql_unixodbc \
		--with-systemd \
		--with-radlast

%:
	dh $@

=== debian/tests/control ===
Tests: freeradius daemon clients
Depends: freeradius, freeradius-utils, python3, python3-passlib, lsb-release
Restrictions: needs-root

Tests: rlm_python3-test
Depends: freeradius, freeradius-python3, freeradius-utils
Restrictions: needs-root

=== debian/watch ===
version=3

opts=pasv,\
pgpsigurlmangle=s/$/.sig/,\
repacksuffix=+dfsg,\
dversionmangle=s/\+(git$|dfsg)//,\
uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/\
  https://www.freeradius.org/ftp/pub/freeradius/freeradius-server-(3\.2\..+)\.tar\.gz
